close all;clear all;clc;

load('BEADS_DATA-Series001.mat');
Prop.dx = .410;
Prop.dy = .410;
Prop.Xd = 409;
Prop.Yd = 512;
Prop.dz = 2.0;
Prop.Zd = 26;
Prop.Td = 230;
Prop.dt = 5.0;

for i=1:length(Pos_cell),
   P_tmp = Pos_cell{i};
   P_tmp(:, 1) = P_tmp(:, 1)*Prop.dx;
   P_tmp(:, 2) = P_tmp(:, 2)*Prop.dy;
   P_tmp(:, 3) = P_tmp(:, 3)*Prop.dz;
   Pos_cell{i} = P_tmp;
end

T_traj = Get_Trajectories(Pos_cell);

filename = '20111205-BEADS_DATA-Series001.mat';
save(filename, 'Prop', 'Pos_cell', 'T_traj');
%%
close all;clear all;clc;
load('BEADS_DATA-Series002.mat');
Prop.dx = .410;
Prop.dy = .410;
Prop.Xd = 409;
Prop.Yd = 512;
Prop.dz = 2.0;
Prop.Zd = 26;
Prop.Td = 330;
Prop.dt = 5.0;

for i=1:length(Pos_cell),
   P_tmp = Pos_cell{i};
   P_tmp(:, 1) = P_tmp(:, 1)*Prop.dx;
   P_tmp(:, 2) = P_tmp(:, 2)*Prop.dy;
   P_tmp(:, 3) = P_tmp(:, 3)*Prop.dz;
   Pos_cell{i} = P_tmp;
end

T_traj = Get_Trajectories(Pos_cell);

filename = '20111205-BEADS_DATA-Series002.mat';
save(filename, 'Prop', 'Pos_cell', 'T_traj');
%% 
close all;clear all;clc;
load('20111205-BEADS_DATA-Series002.mat');
%% 
close all;clear all;clc;
load('20111205-BEADS_DATA-Series001.mat');
%% Sort the trajectories from shortest to longest
close all;
T_end = length(Pos_cell);
Len_sort = zeros(size(T_traj));
Len_mat = zeros(length(T_traj), T_end);

for i=1:length(Len_sort),
    Len_sort(i) = size(T_traj{i}, 1);
    Len_mat(i, T_traj{i}(1,4):T_traj{i}(end,4)) = 1;
end

figure, plot(Len_sort);
figure, imagesc(Len_mat);

%% Plot all the trajectories
close all;
figure('position', [10 10 700 700]), hold on,
for i=1:length(T_traj),
    plot3(T_traj{i}(:, 1), T_traj{i}(:, 2), T_traj{i}(:, 3), 'b');%, [1 0 0], 'linewidth', 3);
end

   %axis([0 Prop.Xd*Prop.dx 0 Prop.Yd*Prop.dy 0 Prop.Zd*Prop.dz]);
    view([9 4]);
    
%% Plot Trajectories between two time points
t1 = 100; t2 = t1 + 100;
figure('position', [50 50 700 700]), hold on,

T_traj_tmp = Sel_Traj_Len(Sel_Traj_T(T_traj, t1, t2), 20);
for i=1:length(T_traj_tmp),
    plot3(T_traj_tmp{i}(:, 1), T_traj_tmp{i}(:, 2), T_traj_tmp{i}(:, 3), 'r', 'linewidth', 3);
end
view([-1 4]);title(['Trajectories between t1 = ' num2str(t1), ' and t2 = ', num2str(t2)]);