handles.t = round(get(handles.T_slider, 'Value'));set(handles.T_slider, 'Value', handles.t);
handles.z = round(get(handles.Z_slider, 'Value'));set(handles.Z_slider, 'Value', handles.z);

set(handles.T_disp, 'String', [num2str(handles.t), '/', num2str(handles.T_max)]);
set(handles.Z_disp, 'String', [num2str(handles.z), '/', num2str(handles.Z_max)]);

%Ylim = get(handles.axes1, 'Ylim'); Xlim = get(handles.axes1, 'Xlim');

axes(handles.axes1); 

if isempty(handles.Stack_all{handles.t}),
    handles.Stack_all{handles.t} = zeros(512,512,handles.Z_max);count = 1;
    for i=((handles.t-1)*handles.Z_max + 1):(handles.t*handles.Z_max),
        handles.Stack_all{handles.t}(:,:,count) = double(imread(handles.imfile, i));count = count + 1;
    end
end
handles.Stack = handles.Stack_all{handles.t};

if isempty(handles.BW_all{handles.t}),

    [L, Num] = bwlabeln(handles.Stack, 6);   
    BW_tmp.L = L;BW_tmp.Num = Num;
    L_sizes = zeros(Num, 1);
    L_non_zero = find(L ~= 0);
    for i=1:length(L_non_zero),
        id = L(L_non_zero(i));
        L_sizes(id) = L_sizes(id) + 1;
    end
    
    [a, b] = sort(L_sizes);
    a = flipud(a); b = flipud(b);
    
    BW_tmp.L_sort = b;
    BW_tmp.L_sizes = L_sizes;
    handles.BW_all{handles.t} = BW_tmp;
    
    set(handles.N_slider, 'Min', 1);
    set(handles.N_slider, 'Max', Num);
    set(handles.N_slider, 'Value', handles.N_id);
    set(handles.N_slider, 'SliderStep', [1/(Num-1) 10/(Num-1)]);
    set(handles.N_disp, 'String', [num2str(handles.N_id), '/', num2str(Num)]);
    set(handles.N_size, 'String', num2str(L_sizes(b(handles.N_id))));
end

handles.Image = zeros(512,512,3);
handles.Image(:,:,1) = uint8(handles.Stack(:,:,handles.z)/256);
BW_tmp = handles.BW_all{handles.t};
handles.Image(:,:,2) = (BW_tmp.L(:,:,handles.z) == BW_tmp.L_sort(handles.N_id))*1.0;
image(handles.Image);
set(handles.axes1, 'ButtonDownFcn', @(hObject,eventdata) mouseMove)


%{
if handles.surface_flag,
    hold on; plot(handles.axes1, handles.x_surface, handles.y_surface, 'r-*','linewidth', 3);
    if handles.mesoderm_id(1) ~= -1,
        id1 = min(handles.mesoderm_id);id2 = max(handles.mesoderm_id);
        plot(handles.axes1, handles.x_surface(id1:id2), handles.y_surface(id1:id2), 'g-*', 'linewidth', 4);
    else
        plot(handles.axes1, handles.x_surface, handles.y_surface, 'r-*', 'linewidth', 3);
    end
    hold off;
else
    hold on; plot(handles.axes1, [1,1], [1,1024], 'r-*','linewidth', 3);
    plot(handles.axes1, [1,1], [1,1024], 'r-*', 'linewidth', 3);
    hold off;
end
axis([Xlim, Ylim]);axis off;
handles.x_surface = [1,1];
handles.y_surface = [1,1024];
%}